import java.util.ArrayList;
import jq.qde.QualitativeDifferentialEquation;
import jq.qde.QDEState;
import jq.qde.space.QualitativeVariable;
import jq.qde.space.QuantitySpace;
import jq.qde.space.value.QualitativeDirection;
import jq.qde.space.value.TimeValue;
import jq.qsim.QSimListenerAdapter;
import jq.qsim.QSimUtil;
import jq.samplemodels.Ball;

/**
 * @author oursland
 */
public class TestBall {

	public static void main(String[] args) {
		QualitativeDifferentialEquation qde = new Ball();
		final QualitativeVariable y = qde.getVariable("y");
		final QualitativeVariable v = qde.getVariable("v");
		final QualitativeVariable a = qde.getVariable("a");
		TimeValue t0 = (TimeValue) qde.getTimeSpace().getQValue(0);
		QDEState state = new QDEState(t0, qde);
		QuantitySpace aqspace = qde.qspace.getVariableSpace(a);
		// set known initial conditions
		state.setVariableValue(y, y.ZERO, QualitativeDirection.STD);
		state.setVariableValue(v, v.ZERO, QualitativeDirection.DEC);
		state.setVariableValue(a, aqspace.getLandmarkValue("aa"), QualitativeDirection.STD);

		ArrayList results = new ArrayList();
		QSimUtil.doSimulation(qde, state, results, new QSimListenerAdapter());
	}

}
