import java.util.ArrayList;
import jq.qde.QDEQuantitySpace;
import jq.qde.QualitativeDifferentialEquation;
import jq.qde.QDEState;
import jq.qde.space.QualitativeVariable;
import jq.qde.space.value.MagnitudeLandmark;
import jq.qde.space.value.QualitativeDirection;
import jq.qde.space.value.TimeValue;
import jq.qsim.QSimListenerAdapter;
import jq.qsim.QSimUtil;
import jq.samplemodels.Bathtub;

/**
 * @author oursland
 */
public class TestBathtub {

	public static void main(String[] args) {
		QualitativeDifferentialEquation qde = new Bathtub();
		QDEQuantitySpace qspace = qde.qspace;
		final QualitativeVariable amount = qde.getVariable("amount");
		final QualitativeVariable inflow = qde.getVariable("inflow");
		final MagnitudeLandmark if_ = qspace.getVariableSpace(inflow).getLandmarkValue("if*");

//		qde.printSpecification(System.out, "");
//		System.out.println();

		TimeValue t0 = (TimeValue) qde.getTimeSpace().getQValue(0);
		QDEState state = new QDEState(t0, qde);
//		System.out.println("Default State:");
//		state.print(System.out, "");
//		System.out.println();
		
		// set known initial conditions
		state.setVariableMagnitude(amount, qspace.getVariableSpace(amount).getLandmarkValue("0"));
		state.setVariableMagnitude(inflow, if_);
		state.setVariableDirection(inflow, QualitativeDirection.STD);
		
//		System.out.println("Initialized State:");
//		state.print(System.out, "");
//		System.out.println();

		ArrayList resultList = new ArrayList();
		QSimUtil.doSimulation(qde, state, resultList, new QSimListenerAdapter());
	}
}
