package jq.qde.space.value;

import java.io.PrintStream;
import jq.qde.space.TimeVariable;


/**
 * @author oursland
 */
public class TimeLandmark extends MagnitudeLandmark implements TimeValue {
	public static final String TIME_PREFIX = "t_";
	private final int time;
	
	public TimeLandmark(int time, TimeVariable var) {
		super(var.createName(time), var);
		this.time = time;
	}
	
	public void print(PrintStream out) {
		out.print(TIME_PREFIX+time);
	}

	public int getTime() {
		return time;
	}
	
	public String toAbbreviation() {
		return Integer.toString(time);
	}
}
