package jq.qsim.globalfilter;

import oursland.naming.NamableObject;
import jq.qde.QDEState;

/**
 * @author oursland
 */
public class ChangeFilter extends NamableObject implements GlobalFilter {

	public ChangeFilter() {
		super("ChangeFilter: state matches its immediate predecessor");
	}

	public boolean passesFilter(QDEState candidateState, QDEState previousState) {
		return (previousState == null) || (candidateState.qspace != previousState.qspace) || hasStateChanged(candidateState, previousState);
	}

	private boolean hasStateChanged(QDEState candidateState, QDEState previousState) {
		boolean haschange = false;
		// there is always a change at the initial state.
		haschange |= (previousState == null);
		// intervals are always considered changes.
		haschange |= candidateState.getTime().isInterval();
		// test all variable values for changes
		haschange |= !candidateState.isQualitativelyEqual(previousState);
		return haschange;
	}
}
